{% header "Content-Type: application/json" %}

{% set hospitalSlug = craft.request.getPost('hospital') %}
{% set stateSlug = craft.request.getPost('state') %}
{% set specialismSlug = craft.request.getPost('specialism') %}
{% set serviceSlug = craft.request.getPost('service') %}
{% set relateds = ['or'] %}
{% set doctors = [] %}
{% set hospital = '' %}

{% if hospitalSlug %}
    {% set hospital = craft.entries.section('hospitals').slug(hospitalSlug).first() %}
    {% set relateds = relateds | merge([
        {
            targetElement: hospital,
            field: "doctorHospital"
        }
    ]) %}

{% endif %}


{% if stateSlug != '' %}
    {% set state = craft.entries.section('states').slug(stateSlug).first() %}

    {% set hospitals = craft.entries({
        section: 'hospitals',
        relatedTo: {
            targetElement: state,
            field: "hospitalState"
        }
    }) %}

    {% set relateds = relateds | merge([
        {
            targetElement: hospitals,
            field: "doctorHospital"
        }
    ]) %}

{% endif %}

{% if specialismSlug != '' %}

    {% set specialism = craft.entries.section('specialities').slug(specialismSlug).first() %}
    {% set relateds = relateds | merge([
        {
            targetElement: specialism,
            field: "doctorSpecialism"
        }
    ]) %}

{% endif %}

{% if serviceSlug != '' %}

    {% set service = craft.entries.section('services').slug(serviceSlug).first() %}

    {% set relateds = relateds | merge([
        {
            targetElement: service,
            field: "doctorServices"
        }
    ]) %}

{% endif %}

{% set criterias = craft.entries({section: 'doctors', relatedTo: relateds}) %}

{% for criteria in criterias %}

    {% set review = craft.entries.({
        section   : 'reviews',
        relatedTo :{
            targetElement : criteria,
            field         : 'reviewDoctor'
        }
    }).fir %}



    {% set doctors = doctors | merge([
        {
            "id"        : criteria.id,
            "name"      : criteria.doctorName,
            "paperId"   : criteria.doctorPaperId,
            "rating"    : criteria.doctorRating,
            "hospital"  : {
                 "name"     : criteria.doctorHospital[0].hospitalName,
                 "address"  : criteria.doctorHospital[0].hospitalAddress,
                 "rating"   : criteria.doctorHospital[0].hospitalRanking
            },
            "review"    : review
        }
    ]) %}
{% endfor %}


{{doctors|json_encode|raw}}